gnunet-svn
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[gnurl] 08/29: travis: Fix error detection


From: gnunet
Subject: [gnurl] 08/29: travis: Fix error detection
Date: Fri, 10 Jan 2020 23:05:46 +0100

This is an automated email from the git hooks/post-receive script.

ng0 pushed a commit to branch master
in repository gnurl.

commit 9434864770406cc9663437063ecab91820fdd4fe
Author: Jay Satiro <address@hidden>
AuthorDate: Sat Dec 28 01:56:05 2019 -0500

    travis: Fix error detection
    
    - Stop using inline shell scripts for before_script and script sections.
    
    Prior to this change Travis could ignore errors from commands in inline
    scripts. I don't understand how or why it happens. This is a workaround.
    
    Assisted-by: Simon Warta
    
    Ref: https://github.com/travis-ci/travis-ci/issues/1066
    
    Fixes https://github.com/curl/curl/issues/3730
    Closes https://github.com/curl/curl/pull/3755
---
 .travis.yml                                        | 255 +--------------------
 scripts/travis/before_script.sh                    | 107 +++++++++
 .../travis/iconv-env.sh                            |   0
 scripts/travis/script.sh                           | 155 +++++++++++++
 4 files changed, 267 insertions(+), 250 deletions(-)

diff --git a/.travis.yml b/.travis.yml
index 8c77a746a..eacb36493 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -423,258 +423,13 @@ install:
   - if [ "$TRAVIS_OS_NAME" == "osx" ]; then brew reinstall libtool > 
/dev/null; fi
   - if [ "$TRAVIS_OS_NAME" == "osx" ]; then brew install rtmpdump libssh2 
c-ares libmetalink libressl nghttp2 libmetalink; fi
 
+# before_script and script:
+# Travis isn't reliable catching errors in inline script commands (#3730).
+# Do not add anything here, instead add to the respective script.
 before_script:
-    - ./buildconf
-    - |
-      if [ "$NGTCP2" = yes ]; then
-       (cd $HOME &&
-       git clone --depth 1 -b openssl-quic-draft-23 
https://github.com/tatsuhiro-t/openssl possl &&
-       cd possl &&
-       ./config enable-tls1_3 --prefix=$HOME/ngbuild &&
-       make && make install_sw &&
-
-       cd .. &&
-       git clone --depth 1 https://github.com/ngtcp2/nghttp3
-       cd nghttp3 &&
-       autoreconf -i &&
-       ./configure --prefix=$HOME/ngbuild --enable-lib-only &&
-       make && make install &&
-
-       cd .. &&
-       git clone --depth 1 https://github.com/ngtcp2/ngtcp2 &&
-       cd ngtcp2 &&
-       autoreconf -i &&
-       ./configure PKG_CONFIG_PATH=$HOME/ngbuild/lib/pkgconfig 
LDFLAGS="-Wl,-rpath,$HOME/ngbuild/lib" --prefix=$HOME/ngbuild --enable-lib-only 
&&
-       make && make install)
-      fi
-    - |
-      if [ "$TRAVIS_OS_NAME" = linux -a "$BORINGSSL" ]; then
-        (cd $HOME &&
-        git clone --depth=1 https://boringssl.googlesource.com/boringssl &&
-        cd boringssl &&
-        mkdir build &&
-        cd build &&
-        CXX="g++" CC="gcc" cmake -DCMAKE_BUILD_TYPE=release 
-DBUILD_SHARED_LIBS=1 .. &&
-        make &&
-        cd .. &&
-        mkdir lib &&
-        cd lib &&
-        cp ../build/crypto/libcrypto.so . &&
-        cp ../build/ssl/libssl.so . &&
-        echo "BoringSSL lib dir: "`pwd` &&
-        cd ../build &&
-        make clean && rm -f CMakeCache.txt &&
-        CXX="g++" CC="gcc" cmake -DCMAKE_POSITION_INDEPENDENT_CODE=on .. &&
-        make &&
-        export LIBS=-lpthread )
-      fi
-    - |
-      if [ "$TRAVIS_OS_NAME" = linux -a "$QUICHE" ]; then
-        (cd $HOME &&
-        git clone --depth=1 https://github.com/cloudflare/quiche.git &&
-        curl https://sh.rustup.rs -sSf | sh -s -- -y &&
-        source $HOME/.cargo/env &&
-        cd quiche &&
-        QUICHE_BSSL_PATH=$HOME/boringssl cargo build -v --release --features 
pkg-config-meta)
-      fi
-    - |
-      if [ $TRAVIS_OS_NAME = linux ]; then
-        if [ ! -e $HOME/wolfssl-4.0.0-stable/Makefile ]; then
-          (cd $HOME && \
-          curl -LO 
https://github.com/wolfSSL/wolfssl/archive/v4.0.0-stable.tar.gz && \
-          tar -xzf v4.0.0-stable.tar.gz && \
-          cd wolfssl-4.0.0-stable && \
-          ./autogen.sh && \
-          ./configure --enable-tls13 --enable-all && \
-          touch wolfssl/wolfcrypt/fips.h && \
-          make)
-        fi
-      fi
-    - |
-      if [ $TRAVIS_OS_NAME = linux ]; then
-        if [ ! -e $HOME/mesalink-1.0.0/Makefile ]; then
-          (cd $HOME && \
-          curl https://sh.rustup.rs -sSf | sh -s -- -y && \
-          source $HOME/.cargo/env && \
-          curl -LO 
https://github.com/mesalock-linux/mesalink/archive/v1.0.0.tar.gz && \
-          tar -xzf v1.0.0.tar.gz && \
-          cd mesalink-1.0.0 && \
-          ./autogen.sh && \
-          ./configure --enable-tls13  && \
-          make)
-        fi
-      fi
-    - |
-      if [ $TRAVIS_OS_NAME = linux ]; then
-        if [ ! -e $HOME/nghttp2-1.39.2/Makefile ]; then
-          (cd $HOME && \
-          curl -L 
https://github.com/nghttp2/nghttp2/releases/download/v1.39.2/nghttp2-1.39.2.tar.gz
 |
-          tar xzf - && \
-          cd nghttp2-1.39.2 && \
-          CXX="g++-8" CC="gcc-8" CFLAGS="" LDFLAGS="" LIBS="" ./configure 
--disable-threads --enable-app && \
-          make)
-        fi
-      fi
-    - |
-      if [ $TRAVIS_OS_NAME = linux ]; then
-        (cd $HOME/wolfssl-4.0.0-stable && sudo make install)
-        (cd $HOME/mesalink-1.0.0 && sudo make install)
-        (cd $HOME/nghttp2-1.39.2 && sudo make install)
-      fi
-
+  - ./scripts/travis/before_script.sh || travis_terminate 1
 script:
-    - |
-        set -eo pipefail
-        if [ "$T" = "coverage" ]; then
-             ./configure --enable-debug --disable-shared 
--disable-threaded-resolver --enable-code-coverage --enable-werror 
--enable-alt-svc --with-libssh2
-             make
-             make TFLAGS=-n test-nonflaky
-             make "TFLAGS=-n -e" test-nonflaky
-             tests="1 200 300 500 700 800 900 1000 1100 1200 1302 1400 1502 
3000"
-             make "TFLAGS=-n -t $tests" test-nonflaky
-             coveralls --gcov /usr/bin/gcov-8 --gcov-options '\-lp' -i src -e 
lib -e tests -e docs -b $PWD/src
-             coveralls --gcov /usr/bin/gcov-8 --gcov-options '\-lp' -e src -i 
lib -e tests -e docs -b $PWD/lib
-        fi
-    - |
-        set -eo pipefail
-        if [ "$T" = "torture" ]; then
-             ./configure --enable-debug --disable-shared 
--disable-threaded-resolver --enable-code-coverage --enable-werror 
--enable-alt-svc --with-libssh2
-             make
-             make TFLAGS=-n test-nonflaky
-             make "TFLAGS=-n -e" test-nonflaky
-             tests="1 200 300 500 700 800 900 1000 1100 1200 1302 1400 1502 
3000"
-             make "TFLAGS=-n --shallow=40 -t $tests" test-nonflaky
-        fi
-    - |
-        set -eo pipefail
-        if [ "$T" = "debug" ]; then
-             ./configure --enable-debug --enable-werror $C
-             make && make examples
-             if [ -z $NOTESTS ]; then
-                if [ "$TRAVIS_ARCH" = "aarch64" ] ; then
-                    # TODO: find out why this test is failing on arm64
-                    make "TFLAGS=-n !323" test-nonflaky
-                else
-                    make TFLAGS=-n test-nonflaky
-                fi
-             fi
-        fi
-    - |
-        set -eo pipefail
-        if [ "$T" = "debug-wolfssl" ]; then
-             ./configure --enable-debug --enable-werror $C
-             make
-             make "TFLAGS=-n !313" test-nonflaky
-        fi
-    - |
-        set -eo pipefail
-        if [ "$T" = "debug-mesalink" ]; then
-             ./configure --enable-debug --enable-werror $C
-             make
-             make "TFLAGS=-n !313 !3001" test-nonflaky
-        fi
-    - |
-        set -eo pipefail
-        if [ "$T" = "novalgrind" ]; then
-             ./configure --enable-werror $C
-             make && make examples
-             make TFLAGS=-n test-nonflaky
-        fi
-    - |
-        set -eo pipefail
-        if [ "$T" = "normal" ]; then
-             if [ $TRAVIS_OS_NAME = linux ]; then
-               # Remove system curl to make sure we don't rely on it.
-               # Only done on Linux since we're not permitted to on mac.
-               sudo rm -f /usr/bin/curl
-             fi
-             ./configure --enable-warnings --enable-werror $C
-             make && make examples
-             if [ -z $NOTESTS ]; then
-                make test-nonflaky
-             fi
-             if [ -n $CHECKSRC ]; then
-                echo "enable COPYRIGHTYEAR" > ./docs/examples/.checksrc
-                echo "enable COPYRIGHTYEAR" > ./include/curl/.checksrc
-                make checksrc
-             fi
-        fi
-    - |
-        set -eo pipefail
-        if [ "$T" = "tidy" ]; then
-             ./configure --enable-warnings --enable-werror $C
-             make && make tidy
-        fi
-    - |
-        set -eo pipefail
-        if [ "$T" = "iconv" ]; then
-             source .travis-iconv-env.sh
-             ./configure --enable-debug --enable-werror $C
-             make && make examples
-             make test-nonflaky
-        fi
-    - |
-        set -eo pipefail
-        if [ "$T" = "cmake" ]; then
-             if [ $TRAVIS_OS_NAME = linux ]; then
-                cmake -H. -Bbuild -DCURL_WERROR=ON && cmake --build build
-             else
-                cmake -H. -Bbuild -DOPENSSL_ROOT_DIR=/usr/local/opt/openssl 
-DCURL_DISABLE_LDAP=ON -DCURL_DISABLE_LDAPS=ON && cmake --build build
-             fi
-        fi
-    - |
-        set -eo pipefail
-        if [ "$T" = "distcheck" ]; then
-            # find BOM markers and exit if we do
-            ! git grep `printf '\xef\xbb\xbf'`
-            ./configure
-            make
-            ./maketgz 99.98.97
-            # verify in-tree build - and install it
-            (tar xf curl-99.98.97.tar.gz && \
-             cd curl-99.98.97 && \
-             ./configure --prefix=$HOME/temp && \
-             make && \
-             make TFLAGS=1 test && \
-             make install)
-            # basic check of the installed files
-            bash scripts/installcheck.sh $HOME/temp
-            rm -rf curl-99.98.97
-            # verify out-of-tree build
-            (tar xf curl-99.98.97.tar.gz && \
-             touch curl-99.98.97/docs/{cmdline-opts,libcurl}/Makefile.inc && \
-             mkdir build && \
-             cd build && \
-             ../curl-99.98.97/configure && \
-             make && \
-             make TFLAGS='-p 1 1139' test)
-            # verify cmake build
-            rm -rf curl-99.98.97
-            (tar xf curl-99.98.97.tar.gz && \
-             cd curl-99.98.97 && \
-             mkdir build && \
-             cd build && \
-             cmake .. && \
-             make)
-        fi
-    - |
-        set -eo pipefail
-        if [ "$T" = "fuzzer" ]; then
-          # Download the fuzzer to a temporary folder
-          ./tests/fuzz/download_fuzzer.sh /tmp/curl_fuzzer
-
-          export CURLSRC=$PWD
-
-          # Run the mainline fuzzer test
-          pushd /tmp/curl_fuzzer
-          ./mainline.sh ${CURLSRC}
-          popd
-        fi
-    - |
-        if [ "$T" = "scan-build" ]; then
-             scan-build ./configure --enable-debug --enable-werror $C
-             scan-build --status-bugs make && scan-build --status-bugs make 
examples
-        fi
+  - ./scripts/travis/script.sh || travis_terminate 1
 
 # whitelist branches to avoid testing feature branches twice (as branch and as 
pull request)
 branches:
diff --git a/scripts/travis/before_script.sh b/scripts/travis/before_script.sh
new file mode 100755
index 000000000..60b63ece3
--- /dev/null
+++ b/scripts/travis/before_script.sh
@@ -0,0 +1,107 @@
+#!/bin/bash
+set -eo pipefail
+
+./buildconf
+
+if [ "$NGTCP2" = yes ]; then
+  cd $HOME
+  git clone --depth 1 -b openssl-quic-draft-23 
https://github.com/tatsuhiro-t/openssl possl
+  cd possl
+  ./config enable-tls1_3 --prefix=$HOME/ngbuild
+  make
+  make install_sw
+
+  cd $HOME
+  git clone --depth 1 https://github.com/ngtcp2/nghttp3
+  cd nghttp3
+  autoreconf -i
+  ./configure --prefix=$HOME/ngbuild --enable-lib-only
+  make
+  make install
+
+  cd $HOME
+  git clone --depth 1 https://github.com/ngtcp2/ngtcp2
+  cd ngtcp2
+  autoreconf -i
+  ./configure PKG_CONFIG_PATH=$HOME/ngbuild/lib/pkgconfig 
LDFLAGS="-Wl,-rpath,$HOME/ngbuild/lib" --prefix=$HOME/ngbuild --enable-lib-only
+  make
+  make install
+fi
+
+if [ "$TRAVIS_OS_NAME" = linux -a "$BORINGSSL" ]; then
+  cd $HOME
+  git clone --depth=1 https://boringssl.googlesource.com/boringssl
+  cd boringssl
+  mkdir build
+  cd build
+  CXX="g++" CC="gcc" cmake -DCMAKE_BUILD_TYPE=release -DBUILD_SHARED_LIBS=1 ..
+  make
+  cd ..
+  mkdir lib
+  cd lib
+  cp ../build/crypto/libcrypto.so .
+  cp ../build/ssl/libssl.so .
+  echo "BoringSSL lib dir: "`pwd`
+  cd ../build
+  make clean
+  rm -f CMakeCache.txt
+  CXX="g++" CC="gcc" cmake -DCMAKE_POSITION_INDEPENDENT_CODE=on ..
+  make
+  export LIBS=-lpthread
+fi
+
+if [ "$TRAVIS_OS_NAME" = linux -a "$QUICHE" ]; then
+  cd $HOME
+  git clone --depth=1 https://github.com/cloudflare/quiche.git
+  curl https://sh.rustup.rs -sSf | sh -s -- -y
+  source $HOME/.cargo/env
+  cd $HOME/quiche
+  QUICHE_BSSL_PATH=$HOME/boringssl cargo build -v --release --features 
pkg-config-meta
+fi
+
+# Install common libraries.
+# The library build directories are set to be cached by .travis.yml. If you are
+# changing a build directory name below (eg a version change) then you must
+# change it in .travis.yml `cache: directories:` as well.
+if [ $TRAVIS_OS_NAME = linux ]; then
+  if [ ! -e $HOME/wolfssl-4.0.0-stable/Makefile ]; then
+    cd $HOME
+    curl -LO https://github.com/wolfSSL/wolfssl/archive/v4.0.0-stable.tar.gz
+    tar -xzf v4.0.0-stable.tar.gz
+    cd wolfssl-4.0.0-stable
+    ./autogen.sh
+    ./configure --enable-tls13 --enable-all
+    touch wolfssl/wolfcrypt/fips.h
+    make
+  fi
+
+  cd $HOME/wolfssl-4.0.0-stable
+  sudo make install
+
+  if [ ! -e $HOME/mesalink-1.0.0/Makefile ]; then
+    cd $HOME
+    curl https://sh.rustup.rs -sSf | sh -s -- -y
+    source $HOME/.cargo/env
+    curl -LO https://github.com/mesalock-linux/mesalink/archive/v1.0.0.tar.gz
+    tar -xzf v1.0.0.tar.gz
+    cd mesalink-1.0.0
+    ./autogen.sh
+    ./configure --enable-tls13
+    make
+  fi
+
+  cd $HOME/mesalink-1.0.0
+  sudo make install
+
+  if [ ! -e $HOME/nghttp2-1.39.2/Makefile ]; then
+    cd $HOME
+    curl -LO 
https://github.com/nghttp2/nghttp2/releases/download/v1.39.2/nghttp2-1.39.2.tar.gz
+    tar -xzf nghttp2-1.39.2.tar.gz
+    cd nghttp2-1.39.2
+    CXX="g++-8" CC="gcc-8" CFLAGS="" LDFLAGS="" LIBS="" ./configure 
--disable-threads --enable-app
+    make
+  fi
+
+  cd $HOME/nghttp2-1.39.2
+  sudo make install
+fi
diff --git a/.travis-iconv-env.sh b/scripts/travis/iconv-env.sh
old mode 100644
new mode 100755
similarity index 100%
rename from .travis-iconv-env.sh
rename to scripts/travis/iconv-env.sh
diff --git a/scripts/travis/script.sh b/scripts/travis/script.sh
new file mode 100755
index 000000000..3f587640d
--- /dev/null
+++ b/scripts/travis/script.sh
@@ -0,0 +1,155 @@
+#!/bin/bash
+set -eo pipefail
+
+./buildconf
+
+if [ "$T" = "coverage" ]; then
+  ./configure --enable-debug --disable-shared --disable-threaded-resolver 
--enable-code-coverage --enable-werror --enable-alt-svc --with-libssh2
+  make
+  make TFLAGS=-n test-nonflaky
+  make "TFLAGS=-n -e" test-nonflaky
+  tests="1 200 300 500 700 800 900 1000 1100 1200 1302 1400 1502 3000"
+  make "TFLAGS=-n -t $tests" test-nonflaky
+  coveralls --gcov /usr/bin/gcov-8 --gcov-options '\-lp' -i src -e lib -e 
tests -e docs -b $PWD/src
+  coveralls --gcov /usr/bin/gcov-8 --gcov-options '\-lp' -e src -i lib -e 
tests -e docs -b $PWD/lib
+fi
+
+if [ "$T" = "torture" ]; then
+  ./configure --enable-debug --disable-shared --disable-threaded-resolver 
--enable-code-coverage --enable-werror --enable-alt-svc --with-libssh2
+  make
+  make TFLAGS=-n test-nonflaky
+  make "TFLAGS=-n -e" test-nonflaky
+  tests="1 200 300 500 700 800 900 1000 1100 1200 1302 1400 1502 3000"
+  make "TFLAGS=-n --shallow=40 -t $tests" test-nonflaky
+fi
+
+if [ "$T" = "debug" ]; then
+  ./configure --enable-debug --enable-werror $C
+  make
+  make examples
+  if [ -z $NOTESTS ]; then
+    if [ "$TRAVIS_ARCH" = "aarch64" ] ; then
+      # TODO: find out why this test is failing on arm64
+      make "TFLAGS=-n !323" test-nonflaky
+    else
+      make TFLAGS=-n test-nonflaky
+    fi
+  fi
+fi
+
+if [ "$T" = "debug-wolfssl" ]; then
+  ./configure --enable-debug --enable-werror $C
+  make
+  make "TFLAGS=-n !313" test-nonflaky
+fi
+
+if [ "$T" = "debug-mesalink" ]; then
+  ./configure --enable-debug --enable-werror $C
+  make
+  make "TFLAGS=-n !313 !3001" test-nonflaky
+fi
+
+if [ "$T" = "novalgrind" ]; then
+  ./configure --enable-werror $C
+  make
+  make examples
+  make TFLAGS=-n test-nonflaky
+fi
+
+if [ "$T" = "normal" ]; then
+  if [ $TRAVIS_OS_NAME = linux ]; then
+    # Remove system curl to make sure we don't rely on it.
+    # Only done on Linux since we're not permitted to on mac.
+    sudo rm -f /usr/bin/curl
+  fi
+  ./configure --enable-warnings --enable-werror $C
+  make
+  make examples
+  if [ -z $NOTESTS ]; then
+    make test-nonflaky
+  fi
+  if [ -n $CHECKSRC ]; then
+    echo "enable COPYRIGHTYEAR" > ./docs/examples/.checksrc
+    echo "enable COPYRIGHTYEAR" > ./include/curl/.checksrc
+    make checksrc
+  fi
+fi
+
+if [ "$T" = "tidy" ]; then
+  ./configure --enable-warnings --enable-werror $C
+  make
+  make tidy
+fi
+
+if [ "$T" = "iconv" ]; then
+  source scripts/travis/iconv-env.sh
+  ./configure --enable-debug --enable-werror $C
+  make
+  make examples
+  make test-nonflaky
+fi
+
+if [ "$T" = "cmake" ]; then
+  if [ $TRAVIS_OS_NAME = linux ]; then
+    cmake -H. -Bbuild -DCURL_WERROR=ON
+    cmake --build build
+  else
+    cmake -H. -Bbuild -DOPENSSL_ROOT_DIR=/usr/local/opt/openssl 
-DCURL_DISABLE_LDAP=ON -DCURL_DISABLE_LDAPS=ON
+    cmake --build build
+  fi
+fi
+
+if [ "$T" = "distcheck" ]; then
+  # find BOM markers and exit if we do
+  ! git grep `printf '\xef\xbb\xbf'`
+  ./configure
+  make
+  ./maketgz 99.98.97
+  # verify in-tree build - and install it
+  tar xf curl-99.98.97.tar.gz
+  cd curl-99.98.97
+  ./configure --prefix=$HOME/temp
+  make
+  make TFLAGS=1 test
+  make install
+  # basic check of the installed files
+  cd ..
+  bash scripts/installcheck.sh $HOME/temp
+  rm -rf curl-99.98.97
+  # verify out-of-tree build
+  tar xf curl-99.98.97.tar.gz
+  touch curl-99.98.97/docs/{cmdline-opts,libcurl}/Makefile.inc
+  mkdir build
+  cd build
+  ../curl-99.98.97/configure
+  make
+  make TFLAGS='-p 1 1139' test
+  # verify cmake build
+  cd ..
+  rm -rf curl-99.98.97
+  tar xf curl-99.98.97.tar.gz
+  cd curl-99.98.97
+  mkdir build
+  cd build
+  cmake ..
+  make
+  cd ../..
+fi
+
+if [ "$T" = "fuzzer" ]; then
+  # Download the fuzzer to a temporary folder
+  ./tests/fuzz/download_fuzzer.sh /tmp/curl_fuzzer
+
+  export CURLSRC=$PWD
+
+  # Run the mainline fuzzer test
+  pushd /tmp/curl_fuzzer
+  ./mainline.sh ${CURLSRC}
+  popd
+fi
+
+if [ "$T" = "scan-build" ]; then
+  scan-build ./configure --enable-debug --enable-werror $C
+  scan-build --status-bugs make
+  scan-build --status-bugs make examples
+fi

-- 
To stop receiving notification emails like this one, please contact
address@hidden.



reply via email to

[Prev in Thread] Current Thread [Next in Thread]